//
//
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <io.h>

#include "asn_decode.h"

int main(int argc, char **argv)
{
    int i;
    FILE *Ip, *Op;
    UCHAR *fbuf;
    int flen;
    int fileno;
    char filename[0x100] = "";
    char renamed_file[0x100] = "";
    int quiet = 0;
    int rename_original = 1;

    maja = 1;
    for(i=1; i<argc; i++) {
        if ((argv[i][0] == '-') || (argv[i][0] == '/')) {
            switch (argv[i][1]) {
                case 'd' :
                    asn_debug = 0xff;
                    break;
                case 'm' :
                    maja = 0;
                    break;
                case 'q' :
                    quiet = 1;
                    break;
                case 'r' :
                    rename_original = 0;
                    break;
                case 'h' :
                case '?' :
                default  :
                    printf("\nasn_decode <options> filename");
                    printf("\n    -d enable debug");
                    printf("\n    -m disable maja fixes");
                    printf("\n    -q no debug text");
                    printf("\n    -r don't rename original");
                    return -1;
            }
        }
        else {
            // set filename from command line parameter
            sscanf(argv[i],"%s", filename);
        }
    }
    if (!filename[0]) {
        printf("\nasn_decode <options> filename");
        printf("\n    -d enable debug");
        printf("\n    -m disable maja fixes");
        printf("\n    -q no debug text");
        printf("\n    -r don't rename original");
        return -1;
    }


    //read input file
    if (!quiet) printf("\nReading file, %s", filename);
    Ip = fopen(filename, "rb");
    if (!Ip) {
        if (!quiet) printf(" - failed to open file");
        return -2;
    }
    fileno = _fileno(Ip);
    flen = _filelength(fileno);
    fbuf = (UCHAR *)malloc(flen);
    fread(fbuf, 1, flen, Ip);
    fclose(Ip);

    //is it mheg?
    if ((fbuf[0] != 0xa0) && (fbuf[0] != 0xa1)) {
        if (!quiet) {
            printf(", file is not mheg");
            printf("\nfbuf[] = ");
            for (i=0; i<0x10; i++) {
                printf("%02x ", fbuf[i]);
            }
            printf("\n");
        }
        return -3;
    }

    //rename original
    if (rename_original) {
        strcpy(renamed_file, filename);
        strcat(renamed_file, ".asn1");
        if (!quiet) printf("\nRenaming original file, %s", renamed_file);
        rename(filename, renamed_file);
    }

    //translate + generate output file
    if (!quiet) printf("\nWriting translated file, %s", filename);
    Op = fopen(filename,"wb");
    if (Op != 0) {
        fprintf(Op,"// translated from asn.1 to text\n");
        if (maja) {
            fprintf(Op,"//   tweaked for maja - all text reduced in size by 20%%\n");
            fprintf(Op,"//                    - added default FontAttributes\n");
            fprintf(Op,"//                    - added default TextColour\n");
        }
        asn_decode(Op, fbuf);
        fclose(Op);
    }
    else {
        if (!quiet) printf("- failed to open file");
        return -4;
    }

    return 0;
}
